# Компонент DataBox

Компонент DataBox позволяет хранить данные, необходимые для работы модуля.

Рекомендуемая структура расположения данных:

1. Образ Docker:
   1. Код проекта
   2. Среда с зависимостями
   3. Системные библиотеки и прочие "программные" зависимости
   4. Постоянные файлы настроек
2. DataBox для данных:
   1. Предобученные веса моделей машинного обучения.
   2. Большие и постоянные наборы внешних данных (например, исторические погодные данные для модуля прогноза погоды).
3. DataBox для пользователей:
   1. Изначально - не хранится ничего.
   2. В ходе работы - загруженные пользователями входные данные и выданные модулем выходные данные работы ML-компонентов и пайплайнов.

Пример манифеста компонента DataBox

```yaml
apiVersion: "unified-platform.cs.hse.ru/v1"
kind: DataBox
metadata:
  name: users
  namespace: pu-username-pa-bm99
spec:
  s3DefaultStorage:
    capacity: 1G
```

В данном примере `users` - это имя компонента DataBox, по которому в дальнейшем смогут обращаться другие компоненты и пользователи.

Например, в [ML-компонентах](./mlcmp.md) это имя используется в разделе `connectedBoxes`.

